#![recursion_limit="512"]

#[macro_use]
extern crate stdweb;

#[allow(unused_macros)]
macro_rules! jslog {
	($($tt:tt)*) => {
		$crate::log(&format!($($tt)*));
	};
}

#[allow(unused_macros)]
macro_rules! jserror {
	($($tt:tt)*) => {
		$crate::error(&format!($($tt)*));
	};
}

pub mod api;
pub mod config;
pub mod models;
pub mod ui;
pub mod uitools;
pub mod utils;

#[inline(never)]
fn log(message: &str) {
	yew::services::ConsoleService::new().log(message);
}

#[inline(never)]
#[allow(unused)]
fn error(message: &str) {
	yew::services::ConsoleService::new().error(message);
}

fn main() {
	yew::start_app::<ui::app::MainApp>();
}

// https://galmon.eu/observers.json
